Subject: bug#51650: Autocomplete: first Tab should show *Completions* buffer

From: Eli Zaretskii <[email-masked]>
Date: Sun, 07 Nov 2021 09:28:06 +0200

> From: Carlos Pita <[email-masked]>
> Date: Sun, 7 Nov 2021 01:27:44 -0300
> 
> I might be wrong here, but I believe find-file and friends work in a
> way that is a bit inconvenient as well as a bit inconsistent.
> 
> For example:
> 
> 1. I press C-x C-f and get "Find file: ~/"
> 2. I press Tab once and get the message "Complete, but not unique"
> 3. I press Tab again and the *Completions* buffer appears with
> candidate completions.
> 4. I type "Desk" and press Tab.
> 5. Now I'm at ~/Desktop/ and press Tab again.
> 6. I get the message "Complete, but not unique" but at the same time
> the *Completions* buffer is displayed.
> 
> Now, this is inconvenient since the first time I have to type Tab twice
> in order to get the *Completions* buffer (or ?, which is not very
> handy in most keyboards). AFAICS the first Tab does nothing at all
> except in the rare situation when there is a single completion, in
> other cases the inference that the user could use some help seems not
> too far-fetched to me.

This is a long-standing behavior, which is very convenient with file
names.  It is documented in the node "Completion Exit" in the Emacs
manual.

We should not change this behavior.

> I think that Tab in step 2 should show the message and the list of
> possible completions at the same time.

That'd get in the way of selecting the "complete, but not unique"
candidate.  It is also a distraction.